blob: 6806e14da5c146dbe0cb98cd886b97f6d0141778 [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
17# along with this program; if not, write to the Free Software
18# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
Ollie Lho184a4042005-11-26 21:55:36 +000019#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000020
Ollie Lho184a4042005-11-26 21:55:36 +000021PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000022
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000023###############################################################################
24# Defaults for the toolchain.
25
26# If you want to cross-compile, just run e.g.
27# make CC=i586-pc-msdosdjgpp-gcc
28# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000029#
30# Note for anyone editing this Makefile: gnumake will happily ignore any
31# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000032STRIP ?= strip
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000033INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000034DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000035PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000036MANDIR ?= $(PREFIX)/share/man
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000037CFLAGS ?= -Os -Wall -Wshadow
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000038EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000039RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000040PKG_CONFIG ?= pkg-config
41BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000042
Stefan Taunerfd0d4132012-09-25 21:24:55 +000043# The following parameter changes the default programmer that will be used if there is no -p/--programmer
44# argument given when running flashrom. The predefined setting does not enable any default so that every
45# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
46# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
47# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
48# system attached to an external programmer while the default programmer is set to the internal programmer, and
49# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
50# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
51# values are those specified in enum programmer in programmer.h (which depend on other CONFIG_* options
52# evaluated below, namely those that enable/disable the various programmers).
53# Compilation will fail for unspecified values.
54CONFIG_DEFAULT_PROGRAMMER ?= PROGRAMMER_INVALID
Stefan Tauner265fcac2014-06-02 00:12:23 +000055# The following adds a default parameter for the default programmer set above (only).
56CONFIG_DEFAULT_PROGRAMMER_ARGS ?= ''
57# Example: compiling with
58# make CONFIG_DEFAULT_PROGRAMMER=PROGRAMMER_SERPROG CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
59# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000060
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000061# If your compiler spits out excessive warnings, run make WARNERROR=no
62# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000063WARNERROR ?= yes
64
65ifeq ($(WARNERROR), yes)
66CFLAGS += -Werror
67endif
68
Stefan Taunere37735a2015-01-26 22:03:35 +000069ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000070PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000071override CPPFLAGS += -I$(LIBS_BASE)/include
72override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000073endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000074
Stefan Taunerbfb067b2016-01-07 18:13:07 +000075ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000076override PKG_CONFIG += --static
77override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000078endif
79
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000080# Set LC_ALL=C to minimize influences of the locale.
81# However, this won't work for the majority of relevant commands because they use the $(shell) function and
82# GNU make does not relay variables exported within the makefile to their evironment.
83LC_ALL=C
84export LC_ALL
85
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000086dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000087
88# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
89# in the build details file together with the original stdout output.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000090debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(1) ; }' >&2; { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000091
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000092###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +000093# General OS-specific settings.
94# 1. Prepare for later by gathering information about host and target OS
95# 2. Set compiler flags and parameters according to OSes
96# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000097
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +000098# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +000099HOST_OS ?= $(shell uname)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000100ifeq ($(HOST_OS), MINGW32_NT-5.1)
101# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
102CC = gcc
103endif
104ifneq ($(HOST_OS), SunOS)
Adam Kaufman064b1f22007-02-06 19:47:50 +0000105STRIP_ARGS = -s
106endif
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000107
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000108# Determine the destination OS.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000109# IMPORTANT: The following line must be placed before TARGET_OS is ever used
110# (of course), but should come after any lines setting CC because the line
111# below uses CC itself.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000112override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000113
114ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000115override CPPFLAGS += -I/opt/local/include -I/usr/local/include
116override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000117endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000118
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000119ifeq ($(TARGET_OS), FreeBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000120override CPPFLAGS += -I/usr/local/include
121override LDFLAGS += -L/usr/local/lib
Andriy Gapon65c1b862008-05-22 13:22:45 +0000122endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000123
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000124ifeq ($(TARGET_OS), OpenBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000125override CPPFLAGS += -I/usr/local/include
126override LDFLAGS += -L/usr/local/lib
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000127endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000128
Stefan Taunerc65b8552013-09-12 15:48:39 +0000129ifeq ($(TARGET_OS), NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000130override CPPFLAGS += -I/usr/pkg/include
131override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000132endif
133
134ifeq ($(TARGET_OS), DragonFlyBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000135override CPPFLAGS += -I/usr/local/include
136override LDFLAGS += -L/usr/local/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000137endif
138
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000139ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000140EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000141# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000142override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000143LIBS += -lgetopt
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000144# Bus Pirate, Serprog and PonyProg are not supported under DOS (missing serial support).
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000145ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
146UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
147else
148override CONFIG_BUSPIRATE_SPI = no
149endif
150ifeq ($(CONFIG_SERPROG), yes)
151UNSUPPORTED_FEATURES += CONFIG_SERPROG=yes
152else
153override CONFIG_SERPROG = no
154endif
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000155ifeq ($(CONFIG_PONY_SPI), yes)
156UNSUPPORTED_FEATURES += CONFIG_PONY_SPI=yes
157else
158override CONFIG_PONY_SPI = no
159endif
Urja Rannikko0870b022016-01-31 22:10:29 +0000160# Dediprog, USB-Blaster, PICkit2, CH341A and FT2232 are not supported under DOS (missing USB support).
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000161ifeq ($(CONFIG_DEDIPROG), yes)
162UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
163else
164override CONFIG_DEDIPROG = no
165endif
166ifeq ($(CONFIG_FT2232_SPI), yes)
167UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
168else
169override CONFIG_FT2232_SPI = no
170endif
James Lairdc60de0e2013-03-27 13:00:23 +0000171ifeq ($(CONFIG_USBBLASTER_SPI), yes)
172UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
173else
174override CONFIG_USBBLASTER_SPI = no
175endif
Justin Chevrier66e554b2015-02-08 21:58:10 +0000176ifeq ($(CONFIG_PICKIT2_SPI), yes)
177UNSUPPORTED_FEATURES += CONFIG_PICKIT2_SPI=yes
178else
179override CONFIG_PICKIT2_SPI = no
180endif
Urja Rannikko0870b022016-01-31 22:10:29 +0000181ifeq ($(CONFIG_CH341A_SPI), yes)
182UNSUPPORTED_FEATURES += CONFIG_CH341A_SPI=yes
183else
184override CONFIG_CH341A_SPI = no
185endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000186endif
Ollie Lho184a4042005-11-26 21:55:36 +0000187
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000188# FIXME: Should we check for Cygwin/MSVC as well?
189ifeq ($(TARGET_OS), MinGW)
190EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000191# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000192FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000193# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000194# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000195FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000196# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
197ifeq ($(CONFIG_INTERNAL), yes)
198UNSUPPORTED_FEATURES += CONFIG_INTERNAL=yes
199else
200override CONFIG_INTERNAL = no
201endif
202ifeq ($(CONFIG_RAYER_SPI), yes)
203UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
204else
205override CONFIG_RAYER_SPI = no
206endif
207ifeq ($(CONFIG_NIC3COM), yes)
208UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
209else
210override CONFIG_NIC3COM = no
211endif
212ifeq ($(CONFIG_GFXNVIDIA), yes)
213UNSUPPORTED_FEATURES += CONFIG_GFXNVIDIA=yes
214else
215override CONFIG_GFXNVIDIA = no
216endif
217ifeq ($(CONFIG_SATASII), yes)
218UNSUPPORTED_FEATURES += CONFIG_SATASII=yes
219else
220override CONFIG_SATASII = no
221endif
222ifeq ($(CONFIG_ATAHPT), yes)
223UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
224else
225override CONFIG_ATAHPT = no
226endif
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000227ifeq ($(CONFIG_ATAVIA), yes)
228UNSUPPORTED_FEATURES += CONFIG_ATAVIA=yes
229else
230override CONFIG_ATAVIA = no
231endif
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000232ifeq ($(CONFIG_ATAPROMISE), yes)
233UNSUPPORTED_FEATURES += CONFIG_ATAPROMISE=yes
234else
235override CONFIG_ATAPROMISE = no
236endif
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000237ifeq ($(CONFIG_IT8212), yes)
238UNSUPPORTED_FEATURES += CONFIG_IT8212=yes
239else
240override CONFIG_IT8212 = no
241endif
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000242ifeq ($(CONFIG_DRKAISER), yes)
243UNSUPPORTED_FEATURES += CONFIG_DRKAISER=yes
244else
245override CONFIG_DRKAISER = no
246endif
247ifeq ($(CONFIG_NICREALTEK), yes)
248UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
249else
250override CONFIG_NICREALTEK = no
251endif
252ifeq ($(CONFIG_NICNATSEMI), yes)
253UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
254else
255override CONFIG_NICNATSEMI = no
256endif
257ifeq ($(CONFIG_NICINTEL), yes)
258UNSUPPORTED_FEATURES += CONFIG_NICINTEL=yes
259else
260override CONFIG_NICINTEL = no
261endif
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000262ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
263UNSUPPORTED_FEATURES += CONFIG_NICINTEL_EEPROM=yes
264else
265override CONFIG_NICINTEL_EEPROM = no
266endif
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000267ifeq ($(CONFIG_NICINTEL_SPI), yes)
268UNSUPPORTED_FEATURES += CONFIG_NICINTEL_SPI=yes
269else
270override CONFIG_NICINTEL_SPI = no
271endif
272ifeq ($(CONFIG_OGP_SPI), yes)
273UNSUPPORTED_FEATURES += CONFIG_OGP_SPI=yes
274else
275override CONFIG_OGP_SPI = no
276endif
277ifeq ($(CONFIG_SATAMV), yes)
278UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
279else
280override CONFIG_SATAMV = no
281endif
282endif
283
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000284ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000285ifeq ($(MAKECMDGOALS),)
286.DEFAULT_GOAL := libflashrom.a
287$(info Setting default goal to libflashrom.a)
288endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000289FLASHROM_CFLAGS += -DSTANDALONE
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000290ifeq ($(CONFIG_DUMMY), yes)
291UNSUPPORTED_FEATURES += CONFIG_DUMMY=yes
292else
293override CONFIG_DUMMY = no
294endif
Stefan Taunere0168262016-02-21 11:18:24 +0000295# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
296ifeq ($(CONFIG_ATAPROMISE), yes)
297UNSUPPORTED_FEATURES += CONFIG_ATAPROMISE=yes
298else
299override CONFIG_ATAPROMISE = no
300endif
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000301# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000302ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
303UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
304else
305override CONFIG_BUSPIRATE_SPI = no
306endif
307ifeq ($(CONFIG_SERPROG), yes)
308UNSUPPORTED_FEATURES += CONFIG_SERPROG=yes
309else
310override CONFIG_SERPROG = no
311endif
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000312ifeq ($(CONFIG_PONY_SPI), yes)
313UNSUPPORTED_FEATURES += CONFIG_PONY_SPI=yes
314else
315override CONFIG_PONY_SPI = no
316endif
Stefan Tauner0be072c2016-03-13 15:16:30 +0000317# Dediprog, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000318ifeq ($(CONFIG_DEDIPROG), yes)
319UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
320else
321override CONFIG_DEDIPROG = no
322endif
323ifeq ($(CONFIG_FT2232_SPI), yes)
324UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
325else
326override CONFIG_FT2232_SPI = no
327endif
James Lairdc60de0e2013-03-27 13:00:23 +0000328ifeq ($(CONFIG_USBBLASTER_SPI), yes)
329UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
330else
331override CONFIG_USBBLASTER_SPI = no
332endif
Justin Chevrier66e554b2015-02-08 21:58:10 +0000333ifeq ($(CONFIG_PICKIT2_SPI), yes)
334UNSUPPORTED_FEATURES += CONFIG_PICKIT2_SPI=yes
335else
336override CONFIG_PICKIT2_SPI = no
337endif
Urja Rannikko0870b022016-01-31 22:10:29 +0000338ifeq ($(CONFIG_CH341A_SPI), yes)
339UNSUPPORTED_FEATURES += CONFIG_CH341A_SPI=yes
340else
341override CONFIG_CH341A_SPI = no
342endif
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000343endif
344
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000345ifneq ($(TARGET_OS), Linux)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000346# Android is handled internally as separate OS, but it supports CONFIG_LINUX_SPI and CONFIG_MSTARDDC_SPI
347ifneq ($(TARGET_OS), Android)
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000348ifeq ($(CONFIG_LINUX_SPI), yes)
349UNSUPPORTED_FEATURES += CONFIG_LINUX_SPI=yes
350else
351override CONFIG_LINUX_SPI = no
352endif
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000353ifeq ($(CONFIG_MSTARDDC_SPI), yes)
354UNSUPPORTED_FEATURES += CONFIG_MSTARDDC_SPI=yes
355else
356override CONFIG_MSTARDDC_SPI = no
357endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000358endif
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000359endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000360
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000361ifeq ($(TARGET_OS), Android)
362# Android on x86 (currently) does not provide raw PCI port I/O operations
363ifeq ($(CONFIG_RAYER_SPI), yes)
364UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
365else
366override CONFIG_RAYER_SPI = no
367endif
368endif
369
Stefan Tauner037cd842013-08-25 00:10:56 +0000370###############################################################################
371# General architecture-specific settings.
372# Like above for the OS, below we verify user-supplied options depending on the target architecture.
373
Uwe Hermann44ffd582011-08-20 14:16:00 +0000374# Determine the destination processor architecture.
375# IMPORTANT: The following line must be placed before ARCH is ever used
376# (of course), but should come after any lines setting CC because the line
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000377# below uses CC itself.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000378override ARCH := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E archtest.c 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
Uwe Hermann44ffd582011-08-20 14:16:00 +0000379
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000380# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000381# Right now this means the drivers below only work on x86.
382ifneq ($(ARCH), x86)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000383ifeq ($(CONFIG_NIC3COM), yes)
384UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
385else
386override CONFIG_NIC3COM = no
387endif
388ifeq ($(CONFIG_NICREALTEK), yes)
389UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
390else
391override CONFIG_NICREALTEK = no
392endif
393ifeq ($(CONFIG_NICNATSEMI), yes)
394UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
395else
396override CONFIG_NICNATSEMI = no
397endif
398ifeq ($(CONFIG_RAYER_SPI), yes)
399UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
400else
401override CONFIG_RAYER_SPI = no
402endif
403ifeq ($(CONFIG_ATAHPT), yes)
404UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
405else
406override CONFIG_ATAHPT = no
407endif
Carl-Daniel Hailfingerf636ffc2016-02-20 22:04:39 +0000408ifeq ($(CONFIG_ATAPROMISE), yes)
409UNSUPPORTED_FEATURES += CONFIG_ATAPROMISE=yes
410else
411override CONFIG_ATAPROMISE = no
412endif
Uwe Hermann21b10c62011-07-29 12:13:01 +0000413ifeq ($(CONFIG_SATAMV), yes)
414UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
415else
416override CONFIG_SATAMV = no
417endif
418endif
419
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000420# Disable all drivers needing raw access (memory, PCI, port I/O) on
421# architectures with unknown raw access properties.
422# Right now those architectures are alpha hppa m68k sh s390
423ifneq ($(ARCH),$(filter $(ARCH),x86 mips ppc arm sparc))
424ifeq ($(CONFIG_INTERNAL), yes)
425UNSUPPORTED_FEATURES += CONFIG_INTERNAL=yes
426else
427override CONFIG_INTERNAL = no
428endif
429ifeq ($(CONFIG_RAYER_SPI), yes)
430UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
431else
432override CONFIG_RAYER_SPI = no
433endif
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000434ifeq ($(CONFIG_NIC3COM), yes)
435UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
436else
437override CONFIG_NIC3COM = no
438endif
439ifeq ($(CONFIG_GFXNVIDIA), yes)
440UNSUPPORTED_FEATURES += CONFIG_GFXNVIDIA=yes
441else
442override CONFIG_GFXNVIDIA = no
443endif
444ifeq ($(CONFIG_SATASII), yes)
445UNSUPPORTED_FEATURES += CONFIG_SATASII=yes
446else
447override CONFIG_SATASII = no
448endif
449ifeq ($(CONFIG_ATAHPT), yes)
450UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
451else
452override CONFIG_ATAHPT = no
453endif
454ifeq ($(CONFIG_ATAVIA), yes)
455UNSUPPORTED_FEATURES += CONFIG_ATAVIA=yes
456else
457override CONFIG_ATAVIA = no
458endif
459ifeq ($(CONFIG_ATAPROMISE), yes)
460UNSUPPORTED_FEATURES += CONFIG_ATAPROMISE=yes
461else
462override CONFIG_ATAPROMISE = no
463endif
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000464ifeq ($(CONFIG_DRKAISER), yes)
465UNSUPPORTED_FEATURES += CONFIG_DRKAISER=yes
466else
467override CONFIG_DRKAISER = no
468endif
469ifeq ($(CONFIG_NICREALTEK), yes)
470UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
471else
472override CONFIG_NICREALTEK = no
473endif
474ifeq ($(CONFIG_NICNATSEMI), yes)
475UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
476else
477override CONFIG_NICNATSEMI = no
478endif
479ifeq ($(CONFIG_NICINTEL), yes)
480UNSUPPORTED_FEATURES += CONFIG_NICINTEL=yes
481else
482override CONFIG_NICINTEL = no
483endif
484ifeq ($(CONFIG_NICINTEL_SPI), yes)
485UNSUPPORTED_FEATURES += CONFIG_NICINTEL_SPI=yes
486else
487override CONFIG_NICINTEL_SPI = no
488endif
489ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
490UNSUPPORTED_FEATURES += CONFIG_NICINTEL_EEPROM=yes
491else
492override CONFIG_NICINTEL_EEPROM = no
493endif
494ifeq ($(CONFIG_OGP_SPI), yes)
495UNSUPPORTED_FEATURES += CONFIG_OGP_SPI=yes
496else
497override CONFIG_OGP_SPI = no
498endif
499ifeq ($(CONFIG_SATAMV), yes)
500UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
501else
502override CONFIG_SATAMV = no
503endif
504ifeq ($(CONFIG_IT8212), yes)
505UNSUPPORTED_FEATURES += CONFIG_IT8212=yes
506else
507override CONFIG_IT8212 = no
508endif
509endif
510
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000511###############################################################################
512# Flash chip drivers and bus support infrastructure.
513
Stefan Tauner4404f732013-09-12 08:28:56 +0000514CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000515 sst28sf040.o 82802ab.o \
Stefan Tauner6ee37e22012-12-29 15:03:51 +0000516 sst49lfxxxc.o sst_fwhub.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Aidan Thorntondb4e87d2013-08-27 18:01:53 +0000517 opaque.o sfdp.o en29lv640b.o at45db.o
Sean Nelson5d134642009-12-24 16:54:21 +0000518
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000519###############################################################################
520# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000521
Nico Huber305f4172013-06-14 11:55:26 +0200522LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o helpers.o ich_descriptors.o
Sean Nelson5d134642009-12-24 16:54:21 +0000523
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000524###############################################################################
525# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000526
Stefan Tauner9b32de92014-08-08 23:52:33 +0000527CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000528
Stefan Tauner76347082016-11-27 17:45:49 +0100529# Makefile.version is used when packaging flashrom and is generated by the
530# export rule. If Makefile.version is not found, version info will be obtained
531# using util/getrevision.sh or "unknown" if SCM metadata directory isn't found.
532ifeq ($(wildcard Makefile.version),)
533ifeq ($(wildcard .git),)
534VERSION ?= unknown
535MAN_DATE ?= unknown
536else
537VERSION ?= $(shell ./util/getrevision.sh --local)
538MAN_DATE ?= $(shell ./util/getrevision.sh -d $(PROGRAM).8.tmpl 2>/dev/null)
539# This is also a convenient time to install hooks.
540$(shell ./util/git-hooks/install.sh)
541endif
542else
543include Makefile.version
544endif
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000545
Stefan Tauner76347082016-11-27 17:45:49 +0100546# VERSION equals "offline" if online access is required but the respective git
547# config variable is not set yet.
548ifeq ($(VERSION),offline)
549 $(error Aborting)
550endif
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000551
Stefan Tauner76347082016-11-27 17:45:49 +0100552SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000553
Stefan Tauner76347082016-11-27 17:45:49 +0100554# No spaces in release names unless set explicitly
555RELEASENAME ?= $(shell echo "$(VERSION)" | sed -e 's/ /_/')
556
557# Inform user of the version string
558$(info Replacing all version templates with $(VERSION).)
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000559
Stefan Tauner037cd842013-08-25 00:10:56 +0000560###############################################################################
561# Default settings of CONFIG_* variables.
562
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000563# Always enable internal/onboard support for now.
564CONFIG_INTERNAL ?= yes
565
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000566# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000567CONFIG_SERPROG ?= yes
568
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000569# RayeR SPIPGM hardware support
570CONFIG_RAYER_SPI ?= yes
571
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000572# PonyProg2000 SPI hardware support
573CONFIG_PONY_SPI ?= yes
574
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000575# Always enable 3Com NICs for now.
576CONFIG_NIC3COM ?= yes
577
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000578# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
579CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000580
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000581# Always enable SiI SATA controllers for now.
582CONFIG_SATASII ?= yes
583
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000584# Highpoint (HPT) ATA/RAID controller support.
585# IMPORTANT: This code is not yet working!
586CONFIG_ATAHPT ?= no
587
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000588# VIA VT6421A LPC memory support
589CONFIG_ATAVIA ?= yes
590
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000591# Promise ATA controller support.
592CONFIG_ATAPROMISE ?= no
593
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000594# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000595CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000596
James Lairdc60de0e2013-03-27 13:00:23 +0000597# Always enable Altera USB-Blaster dongles for now.
598CONFIG_USBBLASTER_SPI ?= yes
599
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000600# MSTAR DDC support needs more tests/reviews/cleanups.
601CONFIG_MSTARDDC_SPI ?= no
602
Justin Chevrier66e554b2015-02-08 21:58:10 +0000603# Always enable PICkit2 SPI dongles for now.
604CONFIG_PICKIT2_SPI ?= yes
605
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000606# Always enable dummy tracing for now.
607CONFIG_DUMMY ?= yes
608
609# Always enable Dr. Kaiser for now.
610CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000611
Joerg Fischer5665ef32010-05-21 21:54:07 +0000612# Always enable Realtek NICs for now.
613CONFIG_NICREALTEK ?= yes
614
Andrew Morganc29c2e72010-06-07 22:37:54 +0000615# Disable National Semiconductor NICs until support is complete and tested.
616CONFIG_NICNATSEMI ?= no
617
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000618# Always enable Intel NICs for now.
619CONFIG_NICINTEL ?= yes
620
Idwer Vollering004f4b72010-09-03 18:21:21 +0000621# Always enable SPI on Intel NICs for now.
622CONFIG_NICINTEL_SPI ?= yes
623
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000624# Always enable EEPROM on Intel NICs for now.
625CONFIG_NICINTEL_EEPROM ?= yes
626
Mark Marshall90021f22010-12-03 14:48:11 +0000627# Always enable SPI on OGP cards for now.
628CONFIG_OGP_SPI ?= yes
629
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000630# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000631CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000632
Simon Glassae616512016-01-23 23:27:58 +0000633# Always enable Dediprog SF100 for now.
634CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000635
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000636# Always enable Marvell SATA controllers for now.
637CONFIG_SATAMV ?= yes
638
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000639# Enable Linux spidev interface by default. We disable it on non-Linux targets.
640CONFIG_LINUX_SPI ?= yes
641
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000642# Always enable ITE IT8212F PATA controllers for now.
643CONFIG_IT8212 ?= yes
644
Urja Rannikko0870b022016-01-31 22:10:29 +0000645# Winchiphead CH341A
646CONFIG_CH341A_SPI ?= yes
647
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000648# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000649CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000650
Stefan Taunerf3503372016-02-26 23:51:21 +0000651# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
652ifeq ($(CONFIG_NOTHING), yes)
653 ifeq ($(CONFIG_EVERYTHING), yes)
654 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
655 endif
656 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
657 $(if $(filter yes, $($(var))),\
658 $(eval $(var)=no)))
659endif
660
Patrick Georgiced7ab62015-01-19 19:52:34 +0000661# Enable all features if CONFIG_EVERYTHING=yes is given
662ifeq ($(CONFIG_EVERYTHING), yes)
663$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
664 $(if $(filter no, $($(var))),\
665 $(eval $(var)=yes)))
666endif
667
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000668# Disable feature groups
669ifeq ($(CONFIG_ENABLE_LIBUSB0_PROGRAMMERS), no)
670override CONFIG_PICKIT2_SPI = no
671endif
672ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
673override CONFIG_CH341A_SPI = no
674override CONFIG_DEDIPROG = no
675endif
676ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
Stefan Tauner0be072c2016-03-13 15:16:30 +0000677override CONFIG_INTERNAL = no
678override CONFIG_NIC3COM = no
679override CONFIG_GFXNVIDIA = no
680override CONFIG_SATASII = no
681override CONFIG_ATAHPT = no
682override CONFIG_ATAVIA = no
683override CONFIG_ATAPROMISE = no
684override CONFIG_IT8212 = no
685override CONFIG_DRKAISER = no
686override CONFIG_NICREALTEK = no
687override CONFIG_NICNATSEMI = no
688override CONFIG_NICINTEL = no
689override CONFIG_NICINTEL_SPI = no
690override CONFIG_NICINTEL_EEPROM = no
691override CONFIG_OGP_SPI = no
692override CONFIG_SATAMV = no
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000693endif
694
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000695# Bitbanging SPI infrastructure, default off unless needed.
696ifeq ($(CONFIG_RAYER_SPI), yes)
697override CONFIG_BITBANG_SPI = yes
698else
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000699ifeq ($(CONFIG_PONY_SPI), yes)
700override CONFIG_BITBANG_SPI = yes
701else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000702ifeq ($(CONFIG_INTERNAL), yes)
703override CONFIG_BITBANG_SPI = yes
704else
705ifeq ($(CONFIG_NICINTEL_SPI), yes)
706override CONFIG_BITBANG_SPI = yes
707else
Mark Marshall90021f22010-12-03 14:48:11 +0000708ifeq ($(CONFIG_OGP_SPI), yes)
709override CONFIG_BITBANG_SPI = yes
710else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000711CONFIG_BITBANG_SPI ?= no
712endif
713endif
714endif
Mark Marshall90021f22010-12-03 14:48:11 +0000715endif
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000716endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000717
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000718###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000719# Handle CONFIG_* variables that depend on others set (and verified) above.
720
721# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
722ifeq ($(TARGET_OS), libpayload)
723ifeq ($(CONFIG_INTERNAL), yes)
724ifeq ($(CONFIG_INTERNAL_DMI), no)
725UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
726else
727override CONFIG_INTERNAL_DMI = yes
728endif
729endif
730endif
731
732# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
733CONFIG_INTERNAL_DMI ?= yes
734
735###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000736# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000737# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000738
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000739FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER=$(CONFIG_DEFAULT_PROGRAMMER)'
Stefan Tauner265fcac2014-06-02 00:12:23 +0000740FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000741
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000742ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000743FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000744PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000745ifeq ($(ARCH), x86)
Rudolf Marek70e14592013-07-25 22:58:56 +0000746PROGRAMMER_OBJS += it87spi.o it85spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Nico Huber305f4172013-06-14 11:55:26 +0200747PROGRAMMER_OBJS += ichspi.o dmi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000748ifeq ($(CONFIG_INTERNAL_DMI), yes)
749FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
750endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000751else
752endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000753NEED_LIBPCI += CONFIG_INTERNAL
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000754endif
755
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000756ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000757FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000758PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000759NEED_SERIAL += CONFIG_SERPROG
760NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000761endif
762
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000763ifeq ($(CONFIG_RAYER_SPI), yes)
764FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
765PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000766NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000767endif
768
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000769ifeq ($(CONFIG_PONY_SPI), yes)
770FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
771PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000772NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000773endif
774
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000775ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000776FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000777PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000778endif
779
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000780ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000781FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000782PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000783NEED_LIBPCI += CONFIG_NIC3COM
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000784endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000785
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000786ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000787FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000788PROGRAMMER_OBJS += gfxnvidia.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000789NEED_LIBPCI += CONFIG_GFXNVIDIA
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000790endif
791
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000792ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000793FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000794PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000795NEED_LIBPCI += CONFIG_SATASII
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000796endif
797
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000798ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000799FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000800PROGRAMMER_OBJS += atahpt.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000801NEED_LIBPCI += CONFIG_ATAHPT
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000802endif
803
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000804ifeq ($(CONFIG_ATAVIA), yes)
805FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
806PROGRAMMER_OBJS += atavia.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000807NEED_LIBPCI += CONFIG_ATAVIA
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000808endif
809
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000810ifeq ($(CONFIG_ATAPROMISE), yes)
811FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
812PROGRAMMER_OBJS += atapromise.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000813NEED_LIBPCI += CONFIG_ATAPROMISE
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000814endif
815
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000816ifeq ($(CONFIG_IT8212), yes)
817FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
818PROGRAMMER_OBJS += it8212.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000819NEED_LIBPCI += CONFIG_IT8212
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000820endif
821
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000822ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000823# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000824FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000825NEED_LIBFTDI += CONFIG_FT2232_SPI
James Lairdc60de0e2013-03-27 13:00:23 +0000826PROGRAMMER_OBJS += ft2232_spi.o
827endif
828
829ifeq ($(CONFIG_USBBLASTER_SPI), yes)
830# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000831FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000832NEED_LIBFTDI += CONFIG_USBBLASTER_SPI
James Lairdc60de0e2013-03-27 13:00:23 +0000833PROGRAMMER_OBJS += usbblaster_spi.o
834endif
835
Justin Chevrier66e554b2015-02-08 21:58:10 +0000836ifeq ($(CONFIG_PICKIT2_SPI), yes)
837FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
838PROGRAMMER_OBJS += pickit2_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000839NEED_LIBUSB0 += CONFIG_PICKIT2_SPI
Justin Chevrier66e554b2015-02-08 21:58:10 +0000840endif
841
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000842ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000843FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
844FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
845FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
Alexandru Gagniuc3d06abe2015-12-25 22:42:45 +0000846FEATURE_CFLAGS += $(FTDI_INCLUDES)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000847FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000848# We can't set NEED_LIBUSB0 here because that would transform libftdi auto-enabling
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000849# into a hard requirement for libusb, defeating the purpose of auto-enabling.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000850endif
851
852ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000853FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000854PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000855endif
856
857ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000858FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000859PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000860NEED_LIBPCI += CONFIG_DRKAISER
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000861endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000862
Joerg Fischer5665ef32010-05-21 21:54:07 +0000863ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000864FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000865PROGRAMMER_OBJS += nicrealtek.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000866NEED_LIBPCI += CONFIG_NICREALTEK
Joerg Fischer5665ef32010-05-21 21:54:07 +0000867endif
868
Andrew Morganc29c2e72010-06-07 22:37:54 +0000869ifeq ($(CONFIG_NICNATSEMI), yes)
870FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
871PROGRAMMER_OBJS += nicnatsemi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000872NEED_LIBPCI += CONFIG_NICNATSEMI
Andrew Morganc29c2e72010-06-07 22:37:54 +0000873endif
874
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000875ifeq ($(CONFIG_NICINTEL), yes)
876FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
877PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000878NEED_LIBPCI += CONFIG_NICINTEL
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000879endif
880
Idwer Vollering004f4b72010-09-03 18:21:21 +0000881ifeq ($(CONFIG_NICINTEL_SPI), yes)
882FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
883PROGRAMMER_OBJS += nicintel_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000884NEED_LIBPCI += CONFIG_NICINTEL_SPI
Idwer Vollering004f4b72010-09-03 18:21:21 +0000885endif
886
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000887ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
888FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
889PROGRAMMER_OBJS += nicintel_eeprom.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000890NEED_LIBPCI += CONFIG_NICINTEL_EEPROM
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000891endif
892
Mark Marshall90021f22010-12-03 14:48:11 +0000893ifeq ($(CONFIG_OGP_SPI), yes)
894FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
895PROGRAMMER_OBJS += ogp_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000896NEED_LIBPCI += CONFIG_OGP_SPI
Mark Marshall90021f22010-12-03 14:48:11 +0000897endif
898
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000899ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
900FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000901PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000902NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000903endif
904
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000905ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000906FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000907PROGRAMMER_OBJS += dediprog.o
Nico Huberd99a2bd2016-02-18 21:42:49 +0000908NEED_LIBUSB1 += CONFIG_DEDIPROG
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000909endif
910
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000911ifeq ($(CONFIG_SATAMV), yes)
912FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
913PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000914NEED_LIBPCI += CONFIG_SATAMV
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000915endif
916
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000917ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000918# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000919FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000920PROGRAMMER_OBJS += linux_spi.o
921endif
922
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000923ifeq ($(CONFIG_MSTARDDC_SPI), yes)
924# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000925FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000926NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000927PROGRAMMER_OBJS += mstarddc_spi.o
928endif
929
Urja Rannikko0870b022016-01-31 22:10:29 +0000930ifeq ($(CONFIG_CH341A_SPI), yes)
931FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
932PROGRAMMER_OBJS += ch341a_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000933NEED_LIBUSB1 += CONFIG_CH341A_SPI
Urja Rannikko0870b022016-01-31 22:10:29 +0000934endif
935
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000936ifneq ($(NEED_SERIAL), )
Sean Nelson5d134642009-12-24 16:54:21 +0000937LIB_OBJS += serial.o
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000938endif
939
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000940ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000941ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000942LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000943endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000944endif
945
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000946ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000947CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000948# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
949# libpci may need raw memory, MSR or PCI port I/O on some platforms.
950# Individual drivers might have the same needs as well.
951NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000952FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000953FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000954
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000955PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000956ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000957# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000958PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000959else
960PCILIBS += -lpci
961endif
962endif
963
964ifneq ($(NEED_RAW_ACCESS), )
965# Raw memory, MSR or PCI port I/O access.
966FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
967PROGRAMMER_OBJS += physmap.o hwaccess.o
968
969ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000970# For (i386|x86_64)_iopl(2).
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000971PCILIBS += -l$(shell uname -p)
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000972else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000973ifeq ($(TARGET_OS), OpenBSD)
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000974# For (i386|amd64)_iopl(2).
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000975PCILIBS += -l$(shell uname -m)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000976else
977ifeq ($(TARGET_OS), Darwin)
978# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000979PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000980endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000981endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000982endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000983
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000984endif
985
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000986ifneq ($(NEED_LIBUSB0), )
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000987CHECK_LIBUSB0 = yes
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000988FEATURE_CFLAGS += -D'NEED_LIBUSB0=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000989USBLIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libusb || printf "%s" "-lusb")
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000990endif
991
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000992ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb82016-01-31 22:10:14 +0000993CHECK_LIBUSB1 = yes
994FEATURE_CFLAGS += -D'NEED_LIBUSB1=1'
995# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
996ifeq ($(TARGET_OS),$(filter $(TARGET_OS),FreeBSD DragonFlyBSD))
997USB1LIBS += -lusb
998else
999ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +00001000override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb82016-01-31 22:10:14 +00001001USB1LIBS += -lusb-1.0
1002else
Stefan Tauner45207062016-02-19 08:17:24 +00001003USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
1004override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb82016-01-31 22:10:14 +00001005endif
1006endif
1007endif
1008
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +00001009ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +00001010FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +00001011CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +00001012endif
1013
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001014FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +00001015
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +00001016# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001017FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +00001018
Nico Huber8624e8c2012-11-05 21:46:33 +01001019FEATURE_CFLAGS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-D'HAVE_CLOCK_GETTIME=1'")
1020FEATURE_LIBS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-lrt")
1021
Patrick Georgi97bc95c2011-03-08 07:17:44 +00001022LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +00001023OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +00001024
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001025all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001026ifeq ($(ARCH), x86)
1027 @+$(MAKE) -C util/ich_descriptors_tool/ TARGET_OS=$(TARGET_OS) EXEC_SUFFIX=$(EXEC_SUFFIX)
1028endif
1029
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001030$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Stefan Taunere49edbb82016-01-31 22:10:14 +00001031 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +00001032
Patrick Georgi97bc95c2011-03-08 07:17:44 +00001033libflashrom.a: $(LIBFLASHROM_OBJS)
1034 $(AR) rcs $@ $^
1035 $(RANLIB) $@
1036
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +00001037# TAROPTIONS reduces information leakage from the packager's system.
1038# If other tar programs support command line arguments for setting uid/gid of
1039# stored files, they can be handled here as well.
1040TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001041
Paul Fox05dfbe62009-06-16 21:08:06 +00001042%.o: %.c .features
Stefan Tauner76347082016-11-27 17:45:49 +01001043 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +00001044
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +00001045# Make sure to add all names of generated binaries here.
1046# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001047# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +00001048clean:
Stefan Tauner4c723152016-01-14 22:47:55 +00001049 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a *.o *.d $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001050 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +00001051
Ollie Lho184a4042005-11-26 21:55:36 +00001052distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +00001053 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +00001054
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001055strip: $(PROGRAM)$(EXEC_SUFFIX)
1056 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +00001057
Stefan Tauner56787082011-08-18 02:27:19 +00001058# to define test programs we use verbatim variables, which get exported
1059# to environment variables and are referenced with $$<varname> later
1060
1061define COMPILER_TEST
1062int main(int argc, char **argv)
1063{
1064 (void) argc;
1065 (void) argv;
1066 return 0;
1067}
1068endef
1069export COMPILER_TEST
1070
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001071compiler: featuresavailable
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001072 @printf "Checking for a C compiler... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001073 @echo "$$COMPILER_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001074 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001075 @{ { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .test.c -o .test$(EXEC_SUFFIX) >&2 && \
1076 echo "found." || { echo "not found."; \
1077 rm -f .test.c .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001078 @rm -f .test.c .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001079 @printf "Target arch is "
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +00001080 @# FreeBSD wc will output extraneous whitespace.
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001081 @echo $(ARCH)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +00001082 ( echo "unknown. Aborting."; exit 1)
1083 @printf "%s\n" '$(ARCH)'
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001084 @printf "Target OS is "
1085 @# FreeBSD wc will output extraneous whitespace.
1086 @echo $(TARGET_OS)|wc -w|grep -q '^[[:blank:]]*1[[:blank:]]*$$' || \
1087 ( echo "unknown. Aborting."; exit 1)
1088 @printf "%s\n" '$(TARGET_OS)'
Stefan Taunerd6c17f62013-09-12 14:04:31 +00001089ifeq ($(TARGET_OS), libpayload)
1090 @$(CC) --version 2>&1 | grep -q coreboot || \
1091 ( echo "Warning: It seems you are not using coreboot's reference compiler."; \
1092 echo "This might work but usually does not, please beware." )
1093endif
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +00001094
Stefan Tauner56787082011-08-18 02:27:19 +00001095define LIBPCI_TEST
1096/* Avoid a failing test due to libpci header symbol shadowing breakage */
1097#define index shadow_workaround_index
Stefan Tauner8d21ff12015-01-10 09:33:06 +00001098#if !defined __NetBSD__
Stefan Tauner56787082011-08-18 02:27:19 +00001099#include <pci/pci.h>
Stefan Taunerc65b8552013-09-12 15:48:39 +00001100#else
1101#include <pciutils/pci.h>
1102#endif
Stefan Tauner56787082011-08-18 02:27:19 +00001103struct pci_access *pacc;
1104int main(int argc, char **argv)
1105{
1106 (void) argc;
1107 (void) argv;
1108 pacc = pci_alloc();
1109 return 0;
1110}
1111endef
1112export LIBPCI_TEST
1113
Stefan Tauner56734502015-02-08 21:58:04 +00001114define PCI_GET_DEV_TEST
1115/* Avoid a failing test due to libpci header symbol shadowing breakage */
1116#define index shadow_workaround_index
1117#if !defined __NetBSD__
1118#include <pci/pci.h>
1119#else
1120#include <pciutils/pci.h>
1121#endif
1122struct pci_access *pacc;
1123struct pci_dev *dev = {0};
1124int main(int argc, char **argv)
1125{
1126 (void) argc;
1127 (void) argv;
1128 pacc = pci_alloc();
1129 dev = pci_get_dev(pacc, dev->domain, dev->bus, dev->dev, 1);
1130 return 0;
1131}
1132endef
1133export PCI_GET_DEV_TEST
1134
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001135define LIBUSB0_TEST
Stefan Tauner0cbd8c22015-01-26 22:06:04 +00001136#include "platform.h"
1137#if IS_WINDOWS
1138#include <lusb0_usb.h>
1139#else
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001140#include <usb.h>
Stefan Tauner0cbd8c22015-01-26 22:06:04 +00001141#endif
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001142int main(int argc, char **argv)
1143{
1144 (void) argc;
1145 (void) argv;
1146 usb_init();
1147 return 0;
1148}
1149endef
1150export LIBUSB0_TEST
1151
Stefan Taunere49edbb82016-01-31 22:10:14 +00001152define LIBUSB1_TEST
1153#include <stddef.h>
1154#include <libusb.h>
1155int main(int argc, char **argv)
1156{
1157 (void)argc;
1158 (void)argv;
1159 libusb_init(NULL);
1160 return 0;
1161}
1162endef
1163export LIBUSB1_TEST
1164
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001165hwlibs: compiler
1166 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001167ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001168 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001169 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001170 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001171 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1172 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001173 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001174 echo "Please install libpci headers or disable all features"; \
1175 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +00001176 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001177 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1178 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +00001179 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001180 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001181 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +00001182 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001183 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1184 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001185 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001186 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
1187 echo "yes." || { echo "no."; \
1188 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001189 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
1190 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001191 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001192 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001193 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
1194 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +00001195 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001196 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001197 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001198endif
1199ifeq ($(CHECK_LIBUSB0), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001200 @printf "Checking for libusb-0.1/libusb-compat headers... " | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001201 @echo "$$LIBUSB0_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001202 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001203 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1204 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001205 echo "The following features require libusb-0.1/libusb-compat: $(NEED_LIBUSB0)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001206 echo "Please install libusb-0.1 headers or libusb-compat headers or disable all features"; \
1207 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB0_PROGRAMMERS=no"; \
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001208 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001209 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1210 @printf "Checking if libusb-0.1 is usable... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001211 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USBLIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001212 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USBLIBS) >&2 && \
1213 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001214 echo "The following features require libusb-0.1/libusb-compat: $(NEED_LIBUSB0)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001215 echo "Please install libusb-0.1 or libusb-compat or disable all features"; \
1216 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB0_PROGRAMMERS=no"; \
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001217 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001218 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +00001219 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +00001220endif
Stefan Taunere49edbb82016-01-31 22:10:14 +00001221ifeq ($(CHECK_LIBUSB1), yes)
1222 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
1223 @echo "$$LIBUSB1_TEST" > .test.c
1224 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
1225 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
1226 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001227 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001228 echo "Please install libusb-1.0 headers or disable all features"; \
1229 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb82016-01-31 22:10:14 +00001230 echo "See README for more information."; echo; \
1231 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1232 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
1233 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
1234 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
1235 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001236 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +00001237 echo "Please install libusb-1.0 or disable all features"; \
1238 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb82016-01-31 22:10:14 +00001239 echo "See README for more information."; echo; \
1240 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1241 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
1242endif
Stefan Reinauer53e96252005-12-01 16:19:24 +00001243
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001244.features: features
1245
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001246# If a user does not explicitly request a non-working feature, we should
1247# silently disable it. However, if a non-working (does not compile) feature
1248# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001249# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001250featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00001251ifeq ($(PROGRAMMER_OBJS),)
1252 @echo "You have to enable at least one programmer driver!"
1253 @false
1254endif
1255ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +00001256 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
1257 @false
1258endif
1259
Stefan Tauner56787082011-08-18 02:27:19 +00001260define FTDI_TEST
Stefan Tauner5c316f92015-02-08 21:57:52 +00001261#include <stdlib.h>
Stefan Tauner56787082011-08-18 02:27:19 +00001262#include <ftdi.h>
1263struct ftdi_context *ftdic = NULL;
1264int main(int argc, char **argv)
1265{
1266 (void) argc;
1267 (void) argv;
1268 return ftdi_init(ftdic);
1269}
1270endef
1271export FTDI_TEST
1272
Ilya A. Volynets-Evenbakh2c714ab2012-09-26 00:47:09 +00001273define FTDI_232H_TEST
1274#include <ftdi.h>
1275enum ftdi_chip_type type = TYPE_232H;
1276endef
1277export FTDI_232H_TEST
1278
Stefan Tauner56787082011-08-18 02:27:19 +00001279define UTSNAME_TEST
1280#include <sys/utsname.h>
1281struct utsname osinfo;
1282int main(int argc, char **argv)
1283{
1284 (void) argc;
1285 (void) argv;
1286 uname (&osinfo);
1287 return 0;
1288}
1289endef
1290export UTSNAME_TEST
1291
Stefan Tauner8868db32012-03-13 00:18:19 +00001292define LINUX_SPI_TEST
1293#include <linux/types.h>
1294#include <linux/spi/spidev.h>
1295
1296int main(int argc, char **argv)
1297{
1298 (void) argc;
1299 (void) argv;
1300 return 0;
1301}
1302endef
1303export LINUX_SPI_TEST
1304
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001305define LINUX_I2C_TEST
1306#include <linux/i2c-dev.h>
1307#include <linux/i2c.h>
1308
1309int main(int argc, char **argv)
1310{
1311 (void) argc;
1312 (void) argv;
1313 return 0;
1314}
1315endef
1316export LINUX_I2C_TEST
1317
Nico Huber8624e8c2012-11-05 21:46:33 +01001318define CLOCK_GETTIME_TEST
1319#include <time.h>
1320
1321int main(int argc, char **argv)
1322{
1323 struct timespec res;
1324 clock_gettime(CLOCK_REALTIME, &res);
1325 return 0;
1326}
1327endef
1328export CLOCK_GETTIME_TEST
1329
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +00001330features: compiler
1331 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001332ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001333 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001334 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001335 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001336 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1337 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
1338 printf "Checking for FT232H support in libftdi... " ; \
1339 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001340 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001341 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
1342 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
1343 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
1344 ) || \
1345 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
1346 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +00001347endif
Stefan Tauner8868db32012-03-13 00:18:19 +00001348ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001349 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001350 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001351 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001352 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +00001353 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001354 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
1355 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001356endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001357ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001358 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001359 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001360 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001361 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001362 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001363 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
1364 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001365endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001366 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001367 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001368 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001369 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001370 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001371 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Nico Huber8624e8c2012-11-05 21:46:33 +01001372 @printf "Checking for clock_gettime support... " | tee -a $(BUILD_DETAILS_FILE)
1373 @echo "$$CLOCK_GETTIME_TEST" >.featuretest.c
1374 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1375 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1376 ( echo "found."; echo "CLOCK_GETTIME := yes" >>.features.tmp ) || \
1377 ( echo "not found."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1378 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001379 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1380 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001381
Stefan Tauner4c723152016-01-14 22:47:55 +00001382$(PROGRAM).8.html: $(PROGRAM).8
1383 @groff -mandoc -Thtml $< >$@
1384
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001385$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001386 @# Add the man page change date and version to the man page
Stefan Tauner76347082016-11-27 17:45:49 +01001387 @sed -e 's#.TH FLASHROM 8 ".*".*#.TH FLASHROM 8 "$(MAN_DATE)" "$(VERSION)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001388
1389install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001390 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001391 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001392 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001393 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001394
Nico Huber454f6132012-12-10 13:34:10 +00001395libinstall: libflashrom.a libflashrom.h
1396 mkdir -p $(DESTDIR)$(PREFIX)/lib
1397 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1398 mkdir -p $(DESTDIR)$(PREFIX)/include
1399 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1400
Stefan Tauner76347082016-11-27 17:45:49 +01001401_export: $(PROGRAM).8
1402 @rm -rf "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
1403 @mkdir -p "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
1404 @git archive HEAD | tar -x -C "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
1405# Generate Makefile.version since SCM metadata won't be available in
1406# exported sources.
1407 @echo "VERSION = $(VERSION)" > "$(EXPORTDIR)/flashrom-$(RELEASENAME)/Makefile.version"
1408 @echo "MAN_DATE = $(MAN_DATE)" >> "$(EXPORTDIR)/flashrom-$(RELEASENAME)/Makefile.version"
1409# Restore modification date of all tracked files not marked
1410# 'export-ignore' in .gitattributes. sed is required to filter out file
1411# names having the attribute set.
1412 @git ls-tree -r -z -t --full-name --name-only HEAD | \
1413 git check-attr -z --stdin export-ignore | \
1414 sed -zne 'x;n;n;/^set$$/{b};x;p' | \
1415 xargs -0 sh -c 'for f; do \
1416 touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
1417 "$(EXPORTDIR)/flashrom-$(RELEASENAME)/$$f"; \
1418 done'
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001419
Stefan Tauner76347082016-11-27 17:45:49 +01001420export: _export
1421 @echo "Exported $(EXPORTDIR)/flashrom-$(RELEASENAME)/"
1422
1423tarball: _export
1424 @tar -cz --format=ustar -f "$(EXPORTDIR)/flashrom-$(RELEASENAME).tar.gz" \
1425 -C "$(EXPORTDIR)/$(TAROPTIONS)" "flashrom-$(RELEASENAME)/"
1426# Delete the exported directory again because it is most likely what's expected by the user.
1427 @rm -rf "$(EXPORTDIR)/flashrom-$(RELEASENAME)"
1428 @echo Created "$(EXPORTDIR)/flashrom-$(RELEASENAME).tar.gz"
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001429
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001430libpayload: clean
1431 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001432
Stefan Tauner76347082016-11-27 17:45:49 +01001433.PHONY: all install clean distclean compiler hwlibs features _export export tarball featuresavailable libpayload
Ollie Lho184a4042005-11-26 21:55:36 +00001434
Stefan Tauner23e10b82016-01-23 16:16:49 +00001435# Disable implicit suffixes and built-in rules (for performance and profit)
1436.SUFFIXES:
1437
Stefan Reinauere2f01582010-06-07 11:08:07 +00001438-include $(OBJS:.o=.d)